unit _12Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ScktComp;

type
  TfrmMainClient = class(TForm)
    lblPort: TLabel;
    edtPort: TSpinEdit;
    lblHost: TLabel;
    edtHost: TEdit;
    btnConnect: TButton;
    btnDisconnect: TButton;
    sckClient: TClientSocket;
    procedure FormCreate(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure sckClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure sckClientWrite(Sender: TObject; Socket: TCustomWinSocket);
  private
    Ranges: TList;
    FConnected: Boolean;
    RcvText: String;
    intBegin, intEnd: Integer;

    procedure UpdateIDE;

    procedure PerformCommands;

    function FindRange: String;
    function IsPrime(Num: Integer): Boolean;
  public
    { Public declarations }
  end;

var
  frmMainClient: TfrmMainClient;

implementation

uses _12Common;

{$R *.DFM}

procedure TfrmMainClient.UpdateIDE;
var
  b: Boolean;
begin
  b := FConnected;
  btnConnect.Enabled := not b;
  btnDisconnect.Enabled := b;

  lblPort.Enabled := not b;
  edtPort.Enabled := not b;

  lblHost.Enabled := not b;
  edtHost.Enabled := not b;

end;

procedure TfrmMainClient.PerformCommands;
var
  p, i, c, c2, a, a2: Integer;
  cmd: String;
  r: TRange;
begin
  while Pos(cmdEndCommand, RcvText) <> 0 do
  begin
    p := Pos(cmdEndCommand, RcvText);
    cmd := Copy(RcvText, 1, p - 1);
    case cmd[1] of
      cmdNewRange: begin
        intBegin := StrToInt(GetParam(cmd, 2));
        intEnd := StrToInt(GetParam(cmd, 3));
        sckClient.Socket.SendText(FindRange);
      end;
      cmdNumbers: begin
        c := StrToInt(GetParam(cmd, 1));
        i := 2;
        for a := 1 to c do
        begin
          r := TRange.Create;
          r.Kind := rkDone;
          r.intBegin := StrToInt(GetParam(cmd, i));
          Inc(i);
          r.intEnd := StrToInt(GetParam(cmd, i));
          Inc(i);
          r.Numbers := TList.Create;
          c2 := StrToInt(GetParam(cmd, i));
          Inc(i);
          for a2 := 1 to c2 do
          begin
            r.Numbers.Add(Pointer(StrToInt(GetParam(cmd, i))));
            Inc(i);
          end;
          Ranges.Add(r);
          OptimizeRanges(Ranges);
        end;
        sckClient.Socket.SendText(cmdRequestRange + cmdEndCommand);
      end;
    end;
    RcvText := Copy(RcvText, p + 1, MaxInt);
  end;

end;


function TfrmMainClient.FindRange: String;
var
  a, c: Integer;
  s: String;
begin
  S := '';
  c := 0;
  for a := intBegin to intEnd do
  begin
    if IsPrime(a) then
    begin
      S := S + ' ' + IntToStr(a);
      Inc(c);
    end;
  end;
  Result := cmdFoundNumbers + ' ' + IntToStr(intBegin) + ' ' + IntToStr(intEnd) + ' ' + IntToStr(c) + S + cmdEndCommand;
end;

function TfrmMainClient.IsPrime(Num: Integer): Boolean;
var
  a, i, m, rid: Integer;
  f: Boolean;
  r: TRange;
begin
  m := Num div 4 + 1;
  rid := -1;
  while rid = -1 do
  begin
    Application.ProcessMessages;
    for a := 0 to Ranges.Count - 1 do
    begin
      if TRange(Ranges[a]).intEnd >= m then
        rid := a;
    end;
  end;
  Result := True;
  i := 0;
  f := True;
  r := Ranges[rid];
  while (i <= r.Numbers.Count - 1) and f do
  begin
    if Num mod Integer(r.Numbers[i]) = 0 then
    begin
      Result := False;
      f := False;
    end;
    if Integer(r.Numbers[i]) > m then
      f := False;
  end;
end;

procedure TfrmMainClient.FormCreate(Sender: TObject);
begin
  FConnected := False;
  UpdateIDE;
end;

procedure TfrmMainClient.btnConnectClick(Sender: TObject);
begin
  RcvText := '';
  Ranges := TList.Create;
  sckClient.Host := edtHost.Text;
  sckClient.Port := edtPort.Value;
  sckClient.Open;
  FConnected := True;
  UpdateIDE;
end;

procedure TfrmMainClient.btnDisconnectClick(Sender: TObject);
var
  a, c: Integer;
begin
  c := Ranges.Count - 1;
  for a := 0 to c do
    DeleteRange(Ranges, 0);
  Ranges.Free;

  sckClient.Active := False;
  FConnected := False;
  UpdateIDE;
end;

procedure TfrmMainClient.sckClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  UpdateIDE;
  Socket.SendText(cmdRequestNumbers + cmdEndCommand);
end;

procedure TfrmMainClient.sckClientWrite(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  RcvText := RcvText + Socket.ReceiveText;
  PerformCommands;
end;

end.

