unit _12Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ScktComp;

type
  TfrmMainServer = class(TForm)
    btnStart: TButton;
    GroupBox1: TGroupBox;
    lblPort: TLabel;
    edtPort: TSpinEdit;
    lblStart: TLabel;
    lblEnd: TLabel;
    edtStart: TSpinEdit;
    edtEnd: TSpinEdit;
    btnEnd: TButton;
    sckServer: TServerSocket;
    lstNumbers: TListBox;
    Label1: TLabel;
    lblCount: TLabel;
    btnUpdate: TButton;
    dsfsdf: TLabel;
    lblFounded: TLabel;
    btnSave: TButton;
    btnLoad: TButton;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnEndClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sckServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure sckServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure sckServerClientWrite(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure btnUpdateClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
  private
    Ranges: TList;
    Sockets: TList;
    List: TList;

    procedure UpdateIDE;
    procedure UpdateNumberList;

    procedure PerformCommands(ID: Integer);

    function GetSocketID(Socket: TCustomWinSocket): Integer;
  public
    { Public declarations }
  end;

var
  frmMainServer: TfrmMainServer;

implementation

uses _12Common, Math;

{$R *.DFM}

procedure TfrmMainServer.FormCreate(Sender: TObject);
var
  a, i: Integer;
begin
  i := 1;
  for a := 1 to 31 do
    i := i * 2;
  i := i - 1;
  edtEnd.Value := i;
  edtEnd.MaxValue := i;
  edtStart.MaxValue := i;

  UpdateIDE;
end;

procedure TfrmMainServer.UpdateIDE;
var
  b: Boolean;
begin
  b := sckServer.Active;
  lblPort.Enabled := not b;
  edtPort.Enabled := not b;

  lblStart.Enabled := not b;
  edtStart.Enabled := not b;
  lblEnd.Enabled := not b;
  edtEnd.Enabled := not b;
  btnStart.Enabled := not b;
  btnEnd.Enabled := b;
  btnUpdate.Enabled := b;

  btnSave.Enabled := b;
  btnLoad.Enabled := b;
  if b then
    lblCount.Caption := 'Client count: ' + IntToStr(Sockets.Count)
  else
    lblCount.Caption := 'Client count: 0';

end;

procedure TfrmMainServer.UpdateNumberList;
var
  a: Integer;
begin
  lstNumbers.Items.BeginUpdate;
  lstNumbers.Items.Clear;
  for a := 0 to List.Count - 1 do
    lstNumbers.Items.Add(IntToStr(Integer(List[a])));
  lstNumbers.Items.EndUpdate;
  lstNumbers.Update;
end;


function IsPrime(a: Integer): Boolean;
var
  i: Integer;
begin
  Result := True;
  if a <> 2 then
    for i := 2 to a div 2 + 1 do
    begin
      if a mod i = 0 then
        Result := False;
    end;
end;

function IsOptPrime(Num: Integer; List: TList): Boolean;
var
  m, n, i: Integer;
  f: Boolean;
begin
  m := Num div 4 + 1;
  i := 0;
  f := True;
  Result := True;
  while (i <= List.Count - 1) and f do
  begin
    n := Integer(List[i]);

    if Num mod n = 0 then
    begin
      Result := False;
      f := False;
    end;
    if n > m then
      f := False;
    Inc(i);
  end;
end;

procedure TfrmMainServer.btnStartClick(Sender: TObject);
var
  r: TRange;
  a: Integer;
begin
  lstNumbers.Items.Clear;
  Sockets := TList.Create;
  sckServer.Port := edtPort.Value;
  sckServer.Active := True;
  UpdateIDE;

  Ranges := TList.Create;
  r := TRange.Create;
  r.intBegin := 0;
  r.intEnd := Min(999, edtEnd.Value);
  r.Kind := rkDone;
  r.Numbers := TList.Create;
  List := TList.Create;

  Ranges.Add(r);

  a := r.intEnd + 1;
  while (a <= edtEnd.Value) and sckServer.Active do
  begin
    if Sockets.Count > 0 then
    begin
      if IsOptPrime(a, List) then
      begin
        List.Add(Pointer(a));
//        lstNumbers.Items.Add(IntToStr(a));
        lblFounded.Caption := IntToStr(List.Count - 1);
      end;
      Inc(a);
      Sleep(Round(8 / (Sockets.Count + 1)));

    end;
    Application.ProcessMessages;
  end;
  UpdateNumberList;

end;

procedure TfrmMainServer.btnEndClick(Sender: TObject);
var
  a, c: Integer;
begin
  c := Ranges.Count - 1;
  List.Free;
  for a := 0 to c do
    DeleteRange(Ranges, 0);
  Ranges.Free;
  sckServer.Active := False;
  UpdateIDE;
end;

procedure TfrmMainServer.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  r: Word;
begin
  if sckServer.Active then
  begin
    r := MessageDlg('Server is running! Do you want to stop it?', mtWarning, [mbYes, mbNo], 0);
    if r = mrYes then
      btnEnd.OnClick(Self)
    else
      if r = mrNo then
        Action := caNone;
  end;
end;

procedure TfrmMainServer.sckServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  s: TJSocket;
  a: Integer;
begin
  for a := 2 to Min(999, edtEnd.Value) do
  begin
    if IsPrime(a) then
    begin
      List.Add(Pointer(a));
//      lstNumbers.Items.Add(IntToStr(a));
      lstNumbers.Invalidate;
      lblFounded.Caption := IntToStr(List.Count - 1);
    end;
  end;
  if 999 >= edtEnd.Value then
    UpdateNumberList;


  s := TJSocket.Create;
  s.Socket := Socket;
  s.Text := '';
  Sockets.Add(s);
  UpdateIDE;
end;

procedure TfrmMainServer.sckServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  r: Integer;
begin
  r := GetSocketID(Socket);
  if r <> -1 then
  begin
    TJSocket(Sockets[r]).Free;
    Sockets.Delete(r);
  end;      
  UpdateIDE;
end;

function TfrmMainServer.GetSocketID(Socket: TCustomWinSocket): Integer;
var
  a: Integer;
begin
  Result := -1;
  for a := 0 to Sockets.Count - 1 do
    if TJSocket(Sockets[a]).Socket = Socket then
      Result := a;
end;

procedure TfrmMainServer.PerformCommands(ID: Integer);
var
  s: TJSocket;
  p, i, a, b, c, intb, inte: Integer;
  cmd, st: String;
  r: TRange;
begin
  s := TJSocket(Sockets[ID]);
  while Pos(cmdEndCommand, s.Text) <> 0 do
  begin
    p := Pos(cmdEndCommand, s.Text);
    cmd := Copy(s.Text, 1, p - 1);
    case cmd[1] of
      cmdRequestRange: begin
//        r := GetNewRange(Ranges, edtStart.Value, edtEnd.Value);
//        s.Socket.SendText(cmdNewRange + ' ' + IntToStr(r.intBegin) + ' ' + IntToStr(r.intEnd) + cmdEndCommand);
      end;
      cmdRequestNumbers: begin
        st := cmdNumbers + ' ' + IntToStr(Ranges.Count) + ' ';
        for a := 0 to Ranges.Count - 1 do
        begin
          st := st + IntToStr(TRange(Ranges[a]).intBegin) + ' ';
          st := st + IntToStr(TRange(Ranges[a]).intEnd) + ' ';
          st := st + IntToStr(TRange(Ranges[a]).Numbers.Count) + ' ';
          for b := 0 to TRange(Ranges[a]).Numbers.Count - 1 do
            st := st + IntToStr(LongInt(TRange(Ranges[a]).Numbers[b])) + ' ';
        end;
        st := st + cmdEndCommand;
//        s.Socket.SendText(st);
      end;
      cmdFoundNumbers: begin
        intb := StrToInt(GetParam(cmd, 2));
        inte := StrToInt(GetParam(cmd, 3));
        c := StrToInt(GetParam(cmd, 4));
        i := 5;
        for a := 0 to Ranges.Count - 1 do
        begin
          r := TRange(Ranges[a]);
          if r.Kind = rkPending then
            if (r.intBegin = intb) and (r.intEnd = inte) then
            begin
              r.Kind := rkDone;
              for b := 1 to c do
              begin
                r.Numbers.Add(Pointer(StrToInt(GetParam(cmd, i))));
                Inc(i);
              end;
              st := cmdNumbers + ' 1 ';

              st := st + IntToStr(r.intBegin) + ' ';
              st := st + IntToStr(r.intEnd) + ' ';
              st := st + IntToStr(r.Numbers.Count) + ' ';
              for b := 0 to r.Numbers.Count - 1 do
                st := st + IntToStr(LongInt(r.Numbers[b])) + ' ';
              st := st + cmdEndCommand;
{              for b := 0 to Sockets.Count - 1 do
                TJSocket(Sockets[b]).Socket.SendText(st);}
              UpdateNumberList;  
            end;
        end;        
      end;
    end;
    s.Text := Copy(s.Text, p + 1, MaxInt);
  end;
end;

procedure TfrmMainServer.sckServerClientWrite(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i: Integer;
begin
  i := GetSocketID(Socket);
  TJSocket(Sockets[i]).Text := TJSocket(Sockets[i]).Text + Socket.ReceiveText;
  TJSocket(Sockets[i]).Socket := Socket;
  PerformCommands(i);
end;

procedure TfrmMainServer.btnUpdateClick(Sender: TObject);
begin
  UpdateNumberList;
end;

procedure TfrmMainServer.btnSaveClick(Sender: TObject);
begin
  if dlgSave.Execute then
    lstNumbers.Items.SaveToFile(dlgSave.FileName);
end;

procedure TfrmMainServer.btnLoadClick(Sender: TObject);
begin
  if dlgOpen.Execute then
    lstNumbers.Items.LoadFromFile(dlgOpen.FileName);
end;

end.

